Print Friendly

# Class YAHOO.widget.Panel

Package: | YAHOO.widget
Class: | Panel
Extends: | Overlay
Subclasses: | Dialog
Defined In: | container.js

Panel is an implementation of Overlay that behaves like an OS window, with a draggable header and an optional close icon at the top right.

## Public Properties

Property | Defined By
--- | ---
| BOTTOM_LEFT<static> : String | Overlay
<static> Constant representing the top bottom left corner of an element, used for configuring the context eleme...
| BOTTOM_RIGHT<static> : String | Overlay
<static> Constant representing the bottom right corner of an element, used for configuring the context element ...
| CSS_BODY<static> : String | Module
<static> Constant representing the module body
| CSS_FOOTER<static> : String | Module
<static> Constant representing the module footer
| CSS_HEADER<static> : String | Module
<static> Constant representing the module header
| CSS_MODULE<static> : String | Module
<static> Constant for the default CSS class name that represents a Module
| CSS_OVERLAY<static> : String | Overlay
<static> Constant representing the default CSS class used for an Overlay
| CSS_PANEL<static> : String | Panel
<static> Constant representing the default CSS class used for a Panel
| CSS_PANEL_CONTAINER<static> : String | Panel
<static> Constant representing the default CSS class used for a Panel's wrapping container
| TOP_LEFT<static> : String | Overlay
<static> Constant representing the top left corner of an element, used for configuring the context element alig...
| TOP_RIGHT<static> : String | Overlay
<static> Constant representing the top right corner of an element, used for configuring the context element ali...
| body : HTMLElement | Module
The body element, denoted with CSS class "bd"
| browser : String | Module
String representing the current user-agent browser
| cfg : YAHOO.util.Config | Module
The Module's Config object used for monitoring configuration properties.
| contructor : Function | Module
The class's constructor function
| element : HTMLElement | Module
The main module element that contains the header, body, and footer
| footer : HTMLElement | Module
The footer element, denoted with CSS class "ft"
| header : HTMLElement | Module
The header element, denoted with CSS class "hd"
| http : String | Module
<static> Constant representing the prefix path to use for non-secure images
| https : String | Module
<static> Constant representing the prefix path to use for securely served images
| id : String | Module
The id of the element
| imageRoot : String | Module
The String representing the image root
| isSecure : Boolean | Module
Boolean representing whether or not the current browsing context is secure (https)
| javascript : String | Module
<static> Constant representing the url for the "src" attribute of the iframe used to monitor changes to the bro...
| platform : String | Module
String representing the current user-agent platform

## Public Methods

Method | Defined By
--- | ---
| Panel(`String el`, `HTMLElement el`, `Object userConfig`) | Panel
| align(`String elementAlign`, `String contextAlign`) : void | Overlay
Aligns the Overlay to its context element using the specified corner points (represented by the constants TOP_LEFT, T...
| appendToBody(`HTMLElement element`) : void | Module
Appends the passed element to the body. If no body is present, one will be automatically created.
| appendToFooter(`HTMLElement element`) : void | Module
Appends the passed element to the footer. If no footer is present, one will be automatically created.
| appendToHeader(`HTMLElement element`) : void | Module
Appends the passed element to the header. If no header is present, one will be automatically created.
| buildMask() : void | Panel
Builds the mask that is laid over the document when the Panel is configured to be modal.
| buildWrapper() : void | Panel
Builds the wrapping container around the Panel that is used for positioning the shadow and matte underlays. The conta...
| center() : void | Overlay
Centers the container in the viewport.
| configClose(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "close" property is changed. The method controls the appending or hiding of ...
| configConstrainToViewport(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler fired when the "constraintoviewport" property is changed.
| configContext(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler fired when the "context" property is changed.
| configDraggable(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "draggable" property is changed.
| configFixedCenter(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler fired when the "fixedcenter" property is changed.
| configHeight(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "height" property is changed.
| configIframe(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler fired when the "iframe" property is changed.
| configKeyListeners(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "keylisteners" property is changed.
| configModal(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "modal" property is changed. This handler subscribes or unsubscribes to the ...
| configMonitorResize(`String type`, `Object[] args`, `Object obj`) : void | Module
Default event handler for the "monitorresize" configuration property
| configUnderlay(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "underlay" property is changed.
| configVisible(`String type`, `Object[] args`, `Object obj`) : void | Module
Default event handler for changing the visibility property of a Module. By default, this is achieved by switching the...
| configWidth(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "width" property is changed.
| configX(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler fired when the "x" property is changed.
| configXY(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler fired when the "xy" property is changed.
| configY(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler fired when the "y" property is changed.
| configzIndex(`String type`, `Object[] args`, `Object obj`) : void | Panel
The default event handler fired when the "zIndex" property is changed.
| destroy() : void | Module
Removes the Module element from the DOM and sets all child elements to null.
| doCenterOnDOMEvent() : void | Overlay
Center event handler used for centering on scroll/resize, but only if the Overlay is visible
| enforceConstraints(`String type`, `Object[] args`, `Object obj`) : void | Overlay
The default event handler executed when the moveEvent is fired, if the "constraintoviewport" is set to true.
| hide() : void | Module
Hides the Module element by setting the visible configuration property to false. Also fires two events: beforeHideEve...
| hideIframe() : void | Overlay
Hides the iframe shim, if it has been enabled
| hideMacGeckoScrollbars() : void | Overlay
Adds a special CSS class to the Overlay when Mac/Gecko is in use, to work around a Gecko bug where scrollbars cannot ...
| hideMask() : void | Panel
Hides the modality mask.
| init(`String el`, `HTMLElement el`, `Object userConfig`) : void | Panel
The Overlay initialization method, which is executed for Overlay and all of its subclasses. This method is automatica...
| initDefaultConfig() : void | Panel
Initializes the class's configurable properties which can be changed using the Panel's Config object (cfg).
| initEvents() : void | Panel
Initializes the custom events for Module which are fired automatically at appropriate times by the Module class.
| initResizeMonitor() : void | Module
Initialized an empty IFRAME that is placed out of the visible area that can be used to detect text resize.
| moveTo(`Number x`, `Number y`) : void | Overlay
Moves the Overlay to the specified position. This function is identical to calling this.cfg.setProperty("xy", [x,y]);
| onDomResize(`DOMEvent e`, `Object obj`) : void | Panel
Event handler fired when the resize monitor element is resized.
| registerDragDrop() : void | Panel
Registers the Panel's header for drag & drop capability.
| removeMask() : void | Panel
Removes the modality mask.
| render(`String appendToNode`, `HTMLElement appendToNode`) : boolean | Panel
Renders the Panel by inserting the elements that are not already in the main Panel into their correct places. Optiona...
| setBody(`String bodyContent`, `HTMLElement bodyContent`) : void | Module
Sets the Module's body content to the HTML specified, or appends the passed element to the body. If no body is presen...
| setFooter(`String footerContent`, `HTMLElement footerContent`) : void | Module
Sets the Module's footer content to the HTML specified, or appends the passed element to the footer. If no footer is ...
| setHeader(`String headerContent`, `HTMLElement headerContent`) : void | Module
Sets the Module's header content to the HTML specified, or appends the passed element to the header. If no header is ...
| show() : void | Module
Shows the Module element by setting the visible configuration property to true. Also fires two events: beforeShowEven...
| showIframe() : void | Overlay
Shows the iframe shim, if it has been enabled
| showMacGeckoScrollbars() : void | Overlay
Removes a special CSS class from the Overlay when Mac/Gecko is in use, to work around a Gecko bug where scrollbars ca...
| showMask() : void | Panel
Shows the modality mask.
| sizeMask() : void | Panel
Sets the size of the modality mask to cover the entire scrollable area of the document
| sizeUnderlay() : void | Panel
Adjusts the size of the shadow based on the size of the element.
| syncPosition() : void | Overlay
Synchronizes the Panel's "xy", "x", and "y" properties with the Panel's position in the DOM. This is primarily used t...
| toString() : String | Panel
Returns a String representation of the object.
| windowResizeHandler<static>(`DOMEvent e`) : void | Overlay
<static> The DOM event handler used to fire the CustomEvent for window resize
| windowScrollHandler<static>(`DOMEvent e`) : void | Overlay
<static> The DOM event handler used to fire the CustomEvent for window scroll

## Public Events

Event | Defined By
--- | ---
| YAHOO.widget.Overlay.windowResizeEvent : () | Overlay
A singleton CustomEvent used for reacting to the DOM event for window resize
| YAHOO.widget.Overlay.windowScrollEvent : () | Overlay
A singleton CustomEvent used for reacting to the DOM event for window scroll
| appendEvent : () | Module
CustomEvent fired when the Module is appended to the DOM
| beforeHideEvent : () | Module
CustomEvent fired before the Module is hidden
| beforeInitEvent : (`class classRef`) | Module
CustomEvent fired prior to class initalization.
| beforeMoveEvent : (`Number x`, `Number y`) | Overlay
CustomEvent fired before the Overlay is moved.
| beforeRenderEvent : () | Module
CustomEvent fired before the Module is rendered
| beforeShowEvent : () | Module
CustomEvent fired before the Module is shown
| changeBodyEvent : (`String/HTMLElement content`) | Module
CustomEvent fired when the body content of the Module is modified
| changeContentEvent : () | Module
CustomEvent fired when the content of the Module is modified
| changeFooterEvent : (`String/HTMLElement content`) | Module
CustomEvent fired when the footer content of the Module is modified
| changeHeaderEvent : (`String/HTMLElement content`) | Module
CustomEvent fired when the header content of the Module is modified
| destroyEvent : () | Module
CustomEvent fired when the Module is destroyed
| dragEvent : () | Panel
CustomEvent when the Panel is dragged
| hideEvent : () | Module
CustomEvent fired after the Module is hidden
| hideMaskEvent : () | Panel
CustomEvent fired after the modality mask is hidden
| initEvent : (`class classRef`) | Module
CustomEvent fired after class initalization.
| moveEvent : (`Number x`, `Number y`) | Overlay
CustomEvent fired after the Overlay is moved.
| renderEvent : () | Module
CustomEvent fired after the Module is rendered
| showEvent : () | Module
CustomEvent fired after the Module is shown
| showMaskEvent : () | Panel
CustomEvent fired after the modality mask is shown

## Property Details

### BOTTOM_LEFT<static>

`public String BOTTOM_LEFT<static>`
<static> Constant representing the top bottom left corner of an element, used for configuring the context element alignment
This property is defined by Overlay.

### BOTTOM_RIGHT<static>

`public String BOTTOM_RIGHT<static>`
<static> Constant representing the bottom right corner of an element, used for configuring the context element alignment
This property is defined by Overlay.

### CSS_BODY<static>

`public String CSS_BODY<static>`
<static> Constant representing the module body
This property is defined by Module.

### CSS_FOOTER<static>

`public String CSS_FOOTER<static>`
<static> Constant representing the module footer
This property is defined by Module.

### CSS_HEADER<static>

`public String CSS_HEADER<static>`
<static> Constant representing the module header
This property is defined by Module.

### CSS_MODULE<static>

`public String CSS_MODULE<static>`
<static> Constant for the default CSS class name that represents a Module
This property is defined by Module.

### CSS_OVERLAY<static>

`public String CSS_OVERLAY<static>`
<static> Constant representing the default CSS class used for an Overlay
This property is defined by Overlay.

### CSS_PANEL<static>

`public String CSS_PANEL<static>`
<static> Constant representing the default CSS class used for a Panel
This property is defined by Panel.

### CSS_PANEL_CONTAINER<static>

`public String CSS_PANEL_CONTAINER<static>`
<static> Constant representing the default CSS class used for a Panel's wrapping container
This property is defined by Panel.

### TOP_LEFT<static>

`public String TOP_LEFT<static>`
<static> Constant representing the top left corner of an element, used for configuring the context element alignment
This property is defined by Overlay.

### TOP_RIGHT<static>

`public String TOP_RIGHT<static>`
<static> Constant representing the top right corner of an element, used for configuring the context element alignment
This property is defined by Overlay.

### body

`public HTMLElement body`
The body element, denoted with CSS class "bd"
This property is defined by Module.

### browser

`public String browser`
String representing the current user-agent browser
This property is defined by Module.

### cfg

`public YAHOO.util.Config cfg`
The Module's Config object used for monitoring configuration properties.
This property is defined by Module.

### contructor

`public Function contructor`
The class's constructor function
This property is defined by Module.

### element

`public HTMLElement element`
The main module element that contains the header, body, and footer
This property is defined by Module.

### footer

`public HTMLElement footer`
The footer element, denoted with CSS class "ft"
This property is defined by Module.

### header

`public HTMLElement header`
The header element, denoted with CSS class "hd"
This property is defined by Module.

### http

`public String http`
<static> Constant representing the prefix path to use for non-secure images
This property is defined by Module.

### https

`public String https`
<static> Constant representing the prefix path to use for securely served images
This property is defined by Module.

### id

`public String id`
The id of the element
This property is defined by Module.

### imageRoot

`public String imageRoot`
The String representing the image root
This property is defined by Module.

### isSecure

`public Boolean isSecure`
Boolean representing whether or not the current browsing context is secure (https)
This property is defined by Module.

### javascript

`public String javascript`
<static> Constant representing the url for the "src" attribute of the iframe used to monitor changes to the browser's base font size
This property is defined by Module.

### platform

`public String platform`
String representing the current user-agent platform
This property is defined by Module.

## Constructor Details

### Panel

`public function Panel(`String el`, `HTMLElement el`, `Object userConfig`)`
Parameters:

- `el` : String
  The element ID representing the Panel OR
- `el` : HTMLElement
  The element representing the Panel
- `userConfig` : Object
  The configuration object literal containing the configuration that should be set for this Panel. See configuration documentation for more details.

## Method Details

### align

`public function align(`String elementAlign`, `String contextAlign`)`
Aligns the Overlay to its context element using the specified corner points (represented by the constants TOP_LEFT, TOP_RIGHT, BOTTOM_LEFT, and BOTTOM_RIGHT.
Parameters:

- `elementAlign` : String
  The String representing the corner of the Overlay that should be aligned to the context element
- `contextAlign` : String
  The corner of the context element that the elementAlign corner should stick to.

Returns:

- `void`

This method is defined by Overlay.

### appendToBody

`public function appendToBody(`HTMLElement element`)`
Appends the passed element to the body. If no body is present, one will be automatically created.
Parameters:

- `element` : HTMLElement
  The element to append to the body

Returns:

- `void`

This method is defined by Module.

### appendToFooter

`public function appendToFooter(`HTMLElement element`)`
Appends the passed element to the footer. If no footer is present, one will be automatically created.
Parameters:

- `element` : HTMLElement
  The element to append to the footer

Returns:

- `void`

This method is defined by Module.

### appendToHeader

`public function appendToHeader(`HTMLElement element`)`
Appends the passed element to the header. If no header is present, one will be automatically created.
Parameters:

- `element` : HTMLElement
  The element to append to the header

Returns:

- `void`

This method is defined by Module.

### buildMask

`public function buildMask()`
Builds the mask that is laid over the document when the Panel is configured to be modal.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### buildWrapper

`public function buildWrapper()`
Builds the wrapping container around the Panel that is used for positioning the shadow and matte underlays. The container element is assigned to a local instance variable called container, and the element is reinserted inside of it.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### center

`public function center()`
Centers the container in the viewport.
Parameters:

- None.

Returns:

- `void`

This method is defined by Overlay.

### configClose

`public function configClose(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "close" property is changed. The method controls the appending or hiding of the close icon at the top right of the Panel.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### configConstrainToViewport

`public function configConstrainToViewport(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "constraintoviewport" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### configContext

`public function configContext(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "context" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### configDraggable

`public function configDraggable(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "draggable" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### configFixedCenter

`public function configFixedCenter(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "fixedcenter" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### configHeight

`public function configHeight(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "height" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### configIframe

`public function configIframe(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "iframe" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### configKeyListeners

`public function configKeyListeners(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "keylisteners" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### configModal

`public function configModal(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "modal" property is changed. This handler subscribes or unsubscribes to the show and hide events to handle the display or hide of the modality mask.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### configMonitorResize

`public function configMonitorResize(`String type`, `Object[] args`, `Object obj`)`
Default event handler for the "monitorresize" configuration property
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Module.

### configUnderlay

`public function configUnderlay(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "underlay" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### configVisible

`public function configVisible(`String type`, `Object[] args`, `Object obj`)`
Default event handler for changing the visibility property of a Module. By default, this is achieved by switching the "display" style between "block" and "none". This method is responsible for firing showEvent and hideEvent.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Module.

### configWidth

`public function configWidth(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "width" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### configX

`public function configX(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "x" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### configXY

`public function configXY(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "xy" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### configY

`public function configY(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "y" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### configzIndex

`public function configzIndex(`String type`, `Object[] args`, `Object obj`)`
The default event handler fired when the "zIndex" property is changed.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Panel.

### destroy

`public function destroy()`
Removes the Module element from the DOM and sets all child elements to null.
Parameters:

- None.

Returns:

- `void`

This method is defined by Module.

### doCenterOnDOMEvent

`public function doCenterOnDOMEvent()`
Center event handler used for centering on scroll/resize, but only if the Overlay is visible
Parameters:

- None.

Returns:

- `void`

This method is defined by Overlay.

### enforceConstraints

`public function enforceConstraints(`String type`, `Object[] args`, `Object obj`)`
The default event handler executed when the moveEvent is fired, if the "constraintoviewport" is set to true.
Parameters:

- `type` : String
  The CustomEvent type (usually the property name)
- `args` : Object[]
  The CustomEvent arguments. For configuration handlers, args[0] will equal the newly applied value for the property.
- `obj` : Object
  The scope object. For configuration handlers, this will usually equal the owner.

Returns:

- `void`

This method is defined by Overlay.

### hide

`public function hide()`
Hides the Module element by setting the visible configuration property to false. Also fires two events: beforeHideEvent prior to the visibility change, and hideEvent after.
Parameters:

- None.

Returns:

- `void`

This method is defined by Module.

### hideIframe

`public function hideIframe()`
Hides the iframe shim, if it has been enabled
Parameters:

- None.

Returns:

- `void`

This method is defined by Overlay.

### hideMacGeckoScrollbars

`public function hideMacGeckoScrollbars()`
Adds a special CSS class to the Overlay when Mac/Gecko is in use, to work around a Gecko bug where scrollbars cannot be hidden. See https://bugzilla.mozilla.org/show_bug.cgi?id=187435
Parameters:

- None.

Returns:

- `void`

This method is defined by Overlay.

### hideMask

`public function hideMask()`
Hides the modality mask.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### init

`public function init(`String el`, `HTMLElement el`, `Object userConfig`)`
The Overlay initialization method, which is executed for Overlay and all of its subclasses. This method is automatically called by the constructor, and sets up all DOM references for pre-existing markup, and creates required markup if it is not already present.
Parameters:

- `el` : String
  The element ID representing the Overlay OR
- `el` : HTMLElement
  The element representing the Overlay
- `userConfig` : Object
  The configuration object literal containing the configuration that should be set for this Overlay. See configuration documentation for more details.

Returns:

- `void`

This method is defined by Panel.

### initDefaultConfig

`public function initDefaultConfig()`
Initializes the class's configurable properties which can be changed using the Panel's Config object (cfg).
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### initEvents

`public function initEvents()`
Initializes the custom events for Module which are fired automatically at appropriate times by the Module class.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### initResizeMonitor

`public function initResizeMonitor()`
Initialized an empty IFRAME that is placed out of the visible area that can be used to detect text resize.
Parameters:

- None.

Returns:

- `void`

This method is defined by Module.

### moveTo

`public function moveTo(`Number x`, `Number y`)`
Moves the Overlay to the specified position. This function is identical to calling this.cfg.setProperty("xy", [x,y]);
Parameters:

- `x` : Number
  The Overlay's new x position
- `y` : Number
  The Overlay's new y position

Returns:

- `void`

This method is defined by Overlay.

### onDomResize

`public function onDomResize(`DOMEvent e`, `Object obj`)`
Event handler fired when the resize monitor element is resized.
Parameters:

- `e` : DOMEvent
  The resize DOM event
- `obj` : Object
  The scope object

Returns:

- `void`

This method is defined by Panel.

### registerDragDrop

`public function registerDragDrop()`
Registers the Panel's header for drag & drop capability.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### removeMask

`public function removeMask()`
Removes the modality mask.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### render

`public function render(`String appendToNode`, `HTMLElement appendToNode`)`
Renders the Panel by inserting the elements that are not already in the main Panel into their correct places. Optionally appends the Panel to the specified node prior to the render's execution. NOTE: For Panels without existing markup, the appendToNode argument is REQUIRED. If this argument is ommitted and the current element is not present in the document, the function will return false, indicating that the render was a failure.
Parameters:

- `appendToNode` : String
  The element id to which the Module should be appended to prior to rendering OR
- `appendToNode` : HTMLElement
  The element to which the Module should be appended to prior to rendering

Returns:

- `boolean`
  Success or failure of the render

This method is defined by Panel.

### setBody

`public function setBody(`String bodyContent`, `HTMLElement bodyContent`)`
Sets the Module's body content to the HTML specified, or appends the passed element to the body. If no body is present, one will be automatically created.
Parameters:

- `bodyContent` : String
  The HTML used to set the body OR
- `bodyContent` : HTMLElement
  The HTMLElement to append to the body

Returns:

- `void`

This method is defined by Module.

### setFooter

`public function setFooter(`String footerContent`, `HTMLElement footerContent`)`
Sets the Module's footer content to the HTML specified, or appends the passed element to the footer. If no footer is present, one will be automatically created.
Parameters:

- `footerContent` : String
  The HTML used to set the footer OR
- `footerContent` : HTMLElement
  The HTMLElement to append to the footer

Returns:

- `void`

This method is defined by Module.

### setHeader

`public function setHeader(`String headerContent`, `HTMLElement headerContent`)`
Sets the Module's header content to the HTML specified, or appends the passed element to the header. If no header is present, one will be automatically created.
Parameters:

- `headerContent` : String
  The HTML used to set the header OR
- `headerContent` : HTMLElement
  The HTMLElement to append to the header

Returns:

- `void`

This method is defined by Module.

### show

`public function show()`
Shows the Module element by setting the visible configuration property to true. Also fires two events: beforeShowEvent prior to the visibility change, and showEvent after.
Parameters:

- None.

Returns:

- `void`

This method is defined by Module.

### showIframe

`public function showIframe()`
Shows the iframe shim, if it has been enabled
Parameters:

- None.

Returns:

- `void`

This method is defined by Overlay.

### showMacGeckoScrollbars

`public function showMacGeckoScrollbars()`
Removes a special CSS class from the Overlay when Mac/Gecko is in use, to work around a Gecko bug where scrollbars cannot be hidden. See https://bugzilla.mozilla.org/show_bug.cgi?id=187435
Parameters:

- None.

Returns:

- `void`

This method is defined by Overlay.

### showMask

`public function showMask()`
Shows the modality mask.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### sizeMask

`public function sizeMask()`
Sets the size of the modality mask to cover the entire scrollable area of the document
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### sizeUnderlay

`public function sizeUnderlay()`
Adjusts the size of the shadow based on the size of the element.
Parameters:

- None.

Returns:

- `void`

This method is defined by Panel.

### syncPosition

`public function syncPosition()`
Synchronizes the Panel's "xy", "x", and "y" properties with the Panel's position in the DOM. This is primarily used to update position information during drag & drop.
Parameters:

- None.

Returns:

- `void`

This method is defined by Overlay.

### toString

`public function toString()`
Returns a String representation of the object.
Parameters:

- None.

Returns:

- `String`
  The string representation of the Panel.

This method is defined by Panel.

### windowResizeHandler<static>

`public function windowResizeHandler<static>(`DOMEvent e`)`
<static> The DOM event handler used to fire the CustomEvent for window resize
Parameters:

- `e` : DOMEvent
  The DOM resize event

Returns:

- `void`

This method is defined by Overlay.

### windowScrollHandler<static>

`public function windowScrollHandler<static>(`DOMEvent e`)`
<static> The DOM event handler used to fire the CustomEvent for window scroll
Parameters:

- `e` : DOMEvent
  The DOM scroll event

Returns:

- `void`

This method is defined by Overlay.

## Event Details

### YAHOO.widget.Overlay.windowResizeEvent

`public event YAHOO.widget.Overlay.windowResizeEvent`
A singleton CustomEvent used for reacting to the DOM event for window resize
Subscribers will be called with the following parameters:

- None.

This event is defined by Overlay.

### YAHOO.widget.Overlay.windowScrollEvent

`public event YAHOO.widget.Overlay.windowScrollEvent`
A singleton CustomEvent used for reacting to the DOM event for window scroll
Subscribers will be called with the following parameters:

- None.

This event is defined by Overlay.

### appendEvent

`public event appendEvent`
CustomEvent fired when the Module is appended to the DOM
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### beforeHideEvent

`public event beforeHideEvent`
CustomEvent fired before the Module is hidden
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### beforeInitEvent

`public event beforeInitEvent`
CustomEvent fired prior to class initalization.
Subscribers will be called with the following parameters:

- `classRef` : class
  class reference of the initializing class, such as this.beforeInitEvent.fire(YAHOO.widget.Module)

This event is defined by Module.

### beforeMoveEvent

`public event beforeMoveEvent`
CustomEvent fired before the Overlay is moved.
Subscribers will be called with the following parameters:

- `x` : Number
  x coordinate
- `y` : Number
  y coordinate

This event is defined by Overlay.

### beforeRenderEvent

`public event beforeRenderEvent`
CustomEvent fired before the Module is rendered
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### beforeShowEvent

`public event beforeShowEvent`
CustomEvent fired before the Module is shown
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### changeBodyEvent

`public event changeBodyEvent`
CustomEvent fired when the body content of the Module is modified
Subscribers will be called with the following parameters:

- `content` : String/HTMLElement
  String/element representing the new body content

This event is defined by Module.

### changeContentEvent

`public event changeContentEvent`
CustomEvent fired when the content of the Module is modified
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### changeFooterEvent

`public event changeFooterEvent`
CustomEvent fired when the footer content of the Module is modified
Subscribers will be called with the following parameters:

- `content` : String/HTMLElement
  String/element representing the new footer content

This event is defined by Module.

### changeHeaderEvent

`public event changeHeaderEvent`
CustomEvent fired when the header content of the Module is modified
Subscribers will be called with the following parameters:

- `content` : String/HTMLElement
  String/element representing the new header content

This event is defined by Module.

### destroyEvent

`public event destroyEvent`
CustomEvent fired when the Module is destroyed
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### dragEvent

`public event dragEvent`
CustomEvent when the Panel is dragged
Subscribers will be called with the following parameters:

- None.

This event is defined by Panel.

### hideEvent

`public event hideEvent`
CustomEvent fired after the Module is hidden
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### hideMaskEvent

`public event hideMaskEvent`
CustomEvent fired after the modality mask is hidden
Subscribers will be called with the following parameters:

- None.

This event is defined by Panel.

### initEvent

`public event initEvent`
CustomEvent fired after class initalization.
Subscribers will be called with the following parameters:

- `classRef` : class
  class reference of the initializing class, such as this.beforeInitEvent.fire(YAHOO.widget.Module)

This event is defined by Module.

### moveEvent

`public event moveEvent`
CustomEvent fired after the Overlay is moved.
Subscribers will be called with the following parameters:

- `x` : Number
  x coordinate
- `y` : Number
  y coordinate

This event is defined by Overlay.

### renderEvent

`public event renderEvent`
CustomEvent fired after the Module is rendered
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### showEvent

`public event showEvent`
CustomEvent fired after the Module is shown
Subscribers will be called with the following parameters:

- None.

This event is defined by Module.

### showMaskEvent

`public event showMaskEvent`
CustomEvent fired after the modality mask is shown
Subscribers will be called with the following parameters:

- None.

This event is defined by Panel.

yui-ext - Copyright © 2006 Jack Slocum. | Yahoo! UI - Copyright © 2006 Yahoo! Inc.
All rights reserved.